From 404f73e85a924588fd178cddf1a0d81e4d7c5fc5 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Mon, 26 Nov 2018 14:34:47 +0100
Subject: [PATCH 1/2] kernel: Move some old unused stuff out of the way.

---
 sys/dev/smbus/atmel_mxt/atmel_mxt.c |   1 -
 sys/dev/smbus/cyapa/cyapa.c         |   1 -
 sys/kern/subr_input.c               | 150 ----------------------------
 sys/sys/input.h                     |  75 --------------
 4 files changed, 227 deletions(-)
 delete mode 100644 sys/kern/subr_input.c
 delete mode 100644 sys/sys/input.h

diff --git a/sys/dev/smbus/atmel_mxt/atmel_mxt.c b/sys/dev/smbus/atmel_mxt/atmel_mxt.c
index e56ec2910d..5901f8dfb3 100644
--- a/sys/dev/smbus/atmel_mxt/atmel_mxt.c
+++ b/sys/dev/smbus/atmel_mxt/atmel_mxt.c
@@ -153,7 +153,6 @@
 #include <sys/conf.h>
 #include <sys/uio.h>
 #include <sys/fcntl.h>
-/*#include <sys/input.h>*/
 #include <sys/vnode.h>
 #include <sys/sysctl.h>
 #include <sys/event.h>
diff --git a/sys/dev/smbus/cyapa/cyapa.c b/sys/dev/smbus/cyapa/cyapa.c
index 582d5cf2bd..0dfbb6e440 100644
--- a/sys/dev/smbus/cyapa/cyapa.c
+++ b/sys/dev/smbus/cyapa/cyapa.c
@@ -114,7 +114,6 @@
 #include <sys/conf.h>
 #include <sys/uio.h>
 #include <sys/fcntl.h>
-/*#include <sys/input.h>*/
 #include <sys/vnode.h>
 #include <sys/sysctl.h>
 #include <sys/event.h>
diff --git a/sys/kern/subr_input.c b/sys/kern/subr_input.c
deleted file mode 100644
index da95cada0b..0000000000
--- a/sys/kern/subr_input.c
+++ /dev/null
@@ -1,150 +0,0 @@
-/*
- * Copyright (c) 2014 The DragonFly Project.  All rights reserved.
- *
- * This code is derived from software contributed to The DragonFly Project
- * by Matthew Dillon <dillon@backplane.com>
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- * 3. Neither the name of The DragonFly Project nor the names of its
- *    contributors may be used to endorse or promote products derived
- *    from this software without specific, prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
- * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
- * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
- * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
- * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
- * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
- * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
- * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
- * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- */
-/*
- * Implement a linux-compatible user even input interface.  This is used by
- * various devices to supply an event stream and ioctls to userland.
- */
-
-#include <sys/param.h>
-#include <sys/queue.h>
-#include <sys/malloc.h>
-#include <sys/kernel.h>
-#include <sys/bus_private.h>
-#include <sys/systm.h>
-#include <sys/uio.h>
-#include <sys/machintr.h>
-
-#include <machine/stdarg.h>	/* for device_printf() */
-
-#include <sys/thread2.h>
-#include <sys/input.h>
-
-MALLOC_DEFINE(M_INPUT, "input", "Input Event");
-
-void
-inputev_init(inputev_t *iev, const char *id)
-{
-}
-
-void
-inputev_register(inputev_t *iev)
-{
-}
-
-void
-inputev_deregister(inputev_t *iev)
-{
-}
-
-void
-inputev_mt_slot(inputev_t *iev, int slot)
-{
-}
-
-void
-inputev_mt_sync_frame(inputev_t *iev)
-{
-}
-
-void
-inputev_sync(inputev_t *iev)
-{
-}
-
-void
-inputev_set_evbit(inputev_t *iev, int bit)
-{
-}
-
-void
-inputev_set_keybit(inputev_t *iev, int bit)
-{
-}
-
-void
-inputev_set_propbit(inputev_t *iev, int bit)
-{
-}
-
-void
-inputev_set_abs_params(inputev_t *iev, u_int axis,
-		       int min, int max, int fuzz, int flat)
-{
-}
-
-void
-inputev_set_res(inputev_t *iev, u_int axis, int val)
-{
-}
-
-void
-inputev_mt_report_slot_state(inputev_t *iev, u_int code, int good)
-{
-}
-
-void
-inputev_report_key(inputev_t *iev, u_int code, int val)
-{
-}
-/* EV_KEY */
-
-void
-inputev_report_rel(inputev_t *iev, u_int code, int val)
-{
-}
-/* EV_REL */
-
-void
-inputev_report_abs(inputev_t *iev, u_int code, int val)
-{
-}
-/* EV_ABS */
-
-/*
- * Handle ioctls
- */
-int
-inputev_ioctl(inputev_t *iev, u_long cmd, void *data)
-{
-	return ENOTTY;
-}
-
-/*
- * Supply a data stream to requestors
- */
-int
-inputev_read(inputev_t *iev, struct uio *uio, int ioflag)
-{
-	return EINVAL;
-}
diff --git a/sys/sys/input.h b/sys/sys/input.h
deleted file mode 100644
index 45e3cc85b6..0000000000
--- a/sys/sys/input.h
+++ /dev/null
@@ -1,75 +0,0 @@
-/*
- * Copyright (c) 2014 The DragonFly Project.  All rights reserved.
- *
- * This code is derived from software contributed to The DragonFly Project
- * by Matthew Dillon <dillon@backplane.com>
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- * 3. Neither the name of The DragonFly Project nor the names of its
- *    contributors may be used to endorse or promote products derived
- *    from this software without specific, prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
- * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
- * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
- * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
- * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
- * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
- * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
- * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
- * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- */
-/*
- * Input event user and device API
- */
-
-#ifndef _SYS_INPUT_H_
-#define _SYS_INPUT_H_
-
-#include <sys/linux_types.h>
-#include <contrib/linux/include/uapi/linux/input.h>
-
-struct inputev {
-	int dummy;
-};
-
-typedef struct inputev inputev_t;
-
-#ifdef _KERNEL
-
-void inputev_init(inputev_t *iev, const char *id);
-void inputev_register(inputev_t *iev);
-void inputev_deregister(inputev_t *iev);
-void inputev_sync(inputev_t *iev);
-int inputev_read(inputev_t *iev, struct uio *uio, int ioflag);
-int inputev_ioctl(inputev_t *iev, u_long cmd, void *data);
-void inputev_mt_sync_frame(inputev_t *iev);
-
-void inputev_set_evbit(inputev_t *iev, int bit);
-void inputev_set_keybit(inputev_t *iev, int bit);
-void inputev_set_propbit(inputev_t *iev, int bit);
-void inputev_set_abs_params(inputev_t *iev, u_int axis,
-			int min, int max, int fuzz, int flat);
-void inputev_set_res(inputev_t *iev, u_int axis, int val);
-
-void inputev_mt_slot(inputev_t *iev, int slot);
-void inputev_mt_report_slot_state(inputev_t *iev, u_int code, int good);
-void inputev_report_key(inputev_t *iev, u_int code, int val); /* EV_KEY */
-void inputev_report_rel(inputev_t *iev, u_int code, int val); /* EV_REL */
-void inputev_report_abs(inputev_t *iev, u_int code, int val); /* EV_ABS */
-
-#endif
-
-#endif
-- 
2.19.1